/**
 * 
 */
package com.example.imaeviewer.test;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TypedListener;


public class ImageViewerTest extends Shell {

    /**
     * @param args
     */
    public static void main(String[] args) {
        try {
            Display display = new Display();
            Shell shell = new ImageViewerTest(display, SWT.SHELL_TRIM);
            shell.open();
    
            while (!shell.isDisposed()) {
                if (!display.readAndDispatch()) {
                    display.sleep();
                }
            }
            display.dispose();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * @param display
     * @param style
     */
    public ImageViewerTest(Display display, int style) {
        super(display, style);
        Shell shell = this.getShell();
        // レイアウトの定義
        shell.setSize(450, 350);
        this.setText("イメージ ビューワ");
        shell.setLayout(new GridLayout(2, false));
        // レイアウトに配置する要素（ヴィジェット）
        Label label1 = new Label(shell, SWT.NONE);
        label1.setText("Image");

//        Label labelImage = new Label(shell, SWT.BORDER);
//        GridData gridData = new GridData();
//        gridData.horizontalAlignment = SWT.FILL;
//        gridData.grabExcessHorizontalSpace = true;
//        gridData.verticalAlignment = SWT.FILL;
//        gridData.grabExcessVerticalSpace = true;
//        labelImage.setLayoutData(gridData);
//        labelImage.setText("まだ画像が読み込まれていません");

        Canvas canvas = new Canvas(shell, SWT.BORDER);
        GridData gridData = new GridData();
        gridData.horizontalAlignment = SWT.FILL;
        gridData.grabExcessHorizontalSpace = true;
        gridData.verticalAlignment = SWT.FILL;
        gridData.grabExcessVerticalSpace = true;
        canvas.setLayoutData(gridData);
        
        Composite composite = new Composite(shell, SWT.NONE);
        composite.setLayout(new FillLayout(SWT.HORIZONTAL));
        Button btnFileOpen = new Button(composite, SWT.NULL);
        btnFileOpen.setText("ファイルを開く");
        Button btnClose = new Button(composite, SWT.NULL);
        btnClose.setText("閉じる");
        gridData = new GridData(GridData.HORIZONTAL_ALIGN_END);
        gridData.horizontalSpan = 2;
        composite.setLayoutData(gridData);

        // 「ファイルを開く」ボタンの処理
        btnFileOpen.addSelectionListener(new SelectionListener() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                // 読み込み用ダイアログを開く
                FileDialog fileDlg = new FileDialog(shell, SWT.OPEN);
                String[] exts = { "*.jpg", "*.*" };
                fileDlg.setFilterExtensions(exts);
                String[] filterNames = { "jpegファイル(*.jpg)", "全てのファイル(*.*)" };
                fileDlg.setFilterNames(filterNames);
                fileDlg.setText("画像ファイルを開く");
                String selectedFilename = fileDlg.open();
                if (selectedFilename != null && !selectedFilename.isEmpty()) {
//                    ReadFromImageFile_Label(labelImage, selectedFilename);
                    if(canvas.isListening(SWT.Paint)){
                        canvas.removeListener(SWT.Paint, (TypedListener)canvas.getListeners(SWT.Paint)[0]);
                    }
                    ReadFromImageFile_Canvas(canvas, selectedFilename);
                }
            }
            @Override
            public void widgetDefaultSelected(SelectionEvent e) {
            }
        });

        // 「閉じる」ボタンの処理
        btnClose.addSelectionListener(new SelectionListener() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                shell.dispose();
            }
            @Override
            public void widgetDefaultSelected(SelectionEvent e) {
            }
        });
    }

    /**
     * 画像ファイルを読み込み、Labelヴィジェットに表示する
     * @param label
     * @param filename
     */
    private void ReadFromImageFile_Label(Label label, String filename) {
            try {
                Image image = new Image(this.getDisplay(), filename);
                label.setImage(image);
            } catch (Exception e) {
                e.printStackTrace();
            }
    }

    /**
     * 画像ファイルを読み込み、Canvasヴィジェットに表示する
     * @param canvas
     * @param filename
     */
    private void ReadFromImageFile_Canvas(Canvas canvas, String filename) {
        Image image;
        try {
            image = new Image(canvas.getDisplay(), filename);
        } catch (Exception e1) {
            // TODO 自動生成された catch ブロック
            e1.printStackTrace();
            return;
        }

        canvas.addPaintListener(new PaintListener() {
            @Override
            public void paintControl(PaintEvent e) {
                float imageRatio = (float)image.getImageData().width / (float)image.getImageData().height;
                if(canvas.getSize().y * imageRatio > canvas.getSize().x){
                    e.gc.drawImage(image, 0, 0, image.getImageData().width, image.getImageData().height,
                            0, 0, canvas.getSize().x, (int)(canvas.getSize().x / imageRatio));
                } else {
                    e.gc.drawImage(image, 0, 0, image.getImageData().width, image.getImageData().height,
                            0, 0, (int)(canvas.getSize().y * imageRatio), canvas.getSize().y);
                }
//                e.gc.drawImage(image, 0, 0, image.getImageData().width, image.getImageData().height,
//                        0, 0, canvas.getSize().x, canvas.getSize().y);
            }
        });
        canvas.redraw();
/*
        GC gc = new GC(canvas);
        gc.drawImage(image, 0, 0, image.getImageData().width, image.getImageData().height,
                0, 0, canvas.getSize().x, canvas.getSize().y);
        gc.dispose();
*/
    }
    /*
     * (非 Javadoc)
     * 
     * @see org.eclipse.swt.widgets.Decorations#checkSubclass()
     */
    @Override
    protected void checkSubclass() {
        // super.checkSubclass();       // 自動作成後、手動でコメントアウト
    }
}
